//*****************************************************************************
// (c) Copyright 2009 Xilinx, Inc. All rights reserved.
//
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
//
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
//
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
//
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.
//
//*****************************************************************************
//   ____  ____
//  /   /\/   /
// /___/  \  /   Vendor             : Xilinx
// \   \   \/    Version            : 3.92
//  \   \        Application        : MIG
//  /   /        Filename           : mig.veo
// /___/   /\    Date Last Modified : $Date: 2011/06/02 07:19:03 $
// \   \  /  \   Date Created       : Fri Aug 7 2009
//  \___\/\___\
//
// Purpose     : Template file containing code that can be used as a model
//               for instantiating a CORE Generator module in a HDL design.
// Revision History:
//*****************************************************************************

// The following must be inserted into your Verilog file for this
// core to be instantiated. Change the instance name and port connections
// (in parentheses) to your own signal names.

//----------- Begin Cut here for INSTANTIATION Template ---// INST_TAG

 mig # (
    .C3_P0_MASK_SIZE(4),
    .C3_P0_DATA_PORT_SIZE(32),
    .C3_P1_MASK_SIZE(4),
    .C3_P1_DATA_PORT_SIZE(32),
    .DEBUG_EN(0),
    .C3_MEMCLK_PERIOD(3000),
    .C3_CALIB_SOFT_IP("TRUE"),
    .C3_SIMULATION("FALSE"),
    .C3_RST_ACT_LOW(0),
    .C3_INPUT_CLK_TYPE("SINGLE_ENDED"),
    .C3_MEM_ADDR_ORDER("ROW_BANK_COLUMN"),
    .C3_NUM_DQ_PINS(16),
    .C3_MEM_ADDR_WIDTH(14),
    .C3_MEM_BANKADDR_WIDTH(3),
    .C3_S0_AXI_STRICT_COHERENCY(0),
    .C3_S0_AXI_ENABLE_AP(0),
    .C3_S0_AXI_DATA_WIDTH(32),
    .C3_S0_AXI_SUPPORTS_NARROW_BURST(1),
    .C3_S0_AXI_ADDR_WIDTH(32),
    .C3_S0_AXI_ID_WIDTH(1)
)
u_mig (

    .c3_sys_clk           (c3_sys_clk),
  .c3_sys_rst_i           (c3_sys_rst_i),                        

  .mcb3_dram_dq           (mcb3_dram_dq),  
  .mcb3_dram_a            (mcb3_dram_a),  
  .mcb3_dram_ba           (mcb3_dram_ba),
  .mcb3_dram_ras_n        (mcb3_dram_ras_n),                        
  .mcb3_dram_cas_n        (mcb3_dram_cas_n),                        
  .mcb3_dram_we_n         (mcb3_dram_we_n),                          
  .mcb3_dram_odt          (mcb3_dram_odt),
  .mcb3_dram_cke          (mcb3_dram_cke),                          
  .mcb3_dram_ck           (mcb3_dram_ck),                          
  .mcb3_dram_ck_n         (mcb3_dram_ck_n),       
  .mcb3_dram_dqs          (mcb3_dram_dqs),                          
  .mcb3_dram_dqs_n        (mcb3_dram_dqs_n),
  .mcb3_dram_udqs         (mcb3_dram_udqs),    // for X16 parts                        
  .mcb3_dram_udqs_n       (mcb3_dram_udqs_n),  // for X16 parts
  .mcb3_dram_udm          (mcb3_dram_udm),     // for X16 parts
  .mcb3_dram_dm           (mcb3_dram_dm),
  .mcb3_dram_reset_n      (mcb3_dram_reset_n),
  .c3_clk0		        (c3_clk0),
  .c3_rst0		        (c3_rst0),
	
 

  .c3_calib_done    (c3_calib_done),
     .mcb3_rzq               (rzq3),  
        
     .mcb3_zio               (zio3),
	
     .c3_s0_axi_aclk                         (c3_s0_axi_aclk   ),
   .c3_s0_axi_aresetn                      (c3_s0_axi_aresetn),
   .c3_s0_axi_awid                         (c3_s0_axi_awid   ),
   .c3_s0_axi_awaddr                       (c3_s0_axi_awaddr ),
   .c3_s0_axi_awlen                        (c3_s0_axi_awlen  ),
   .c3_s0_axi_awsize                       (c3_s0_axi_awsize ),
   .c3_s0_axi_awburst                      (c3_s0_axi_awburst),
   .c3_s0_axi_awlock                       (c3_s0_axi_awlock ),
   .c3_s0_axi_awcache                      (c3_s0_axi_awcache),
   .c3_s0_axi_awprot                       (c3_s0_axi_awprot ),
   .c3_s0_axi_awqos                        (c3_s0_axi_awqos  ),
   .c3_s0_axi_awvalid                      (c3_s0_axi_awvalid),
   .c3_s0_axi_awready                      (c3_s0_axi_awready),
   .c3_s0_axi_wdata                        (c3_s0_axi_wdata  ),
   .c3_s0_axi_wstrb                        (c3_s0_axi_wstrb  ),
   .c3_s0_axi_wlast                        (c3_s0_axi_wlast  ),
   .c3_s0_axi_wvalid                       (c3_s0_axi_wvalid ),
   .c3_s0_axi_wready                       (c3_s0_axi_wready ),
   .c3_s0_axi_bid                          (c3_s0_axi_bid    ),
   .c3_s0_axi_wid                          (c3_s0_axi_wid    ),
   .c3_s0_axi_bresp                        (c3_s0_axi_bresp  ),
   .c3_s0_axi_bvalid                       (c3_s0_axi_bvalid ),
   .c3_s0_axi_bready                       (c3_s0_axi_bready ),
   .c3_s0_axi_arid                         (c3_s0_axi_arid   ),
   .c3_s0_axi_araddr                       (c3_s0_axi_araddr ),
   .c3_s0_axi_arlen                        (c3_s0_axi_arlen  ),
   .c3_s0_axi_arsize                       (c3_s0_axi_arsize ),
   .c3_s0_axi_arburst                      (c3_s0_axi_arburst),
   .c3_s0_axi_arlock                       (c3_s0_axi_arlock ),
   .c3_s0_axi_arcache                      (c3_s0_axi_arcache),
   .c3_s0_axi_arprot                       (c3_s0_axi_arprot ),
   .c3_s0_axi_arqos                        (c3_s0_axi_arqos  ),
   .c3_s0_axi_arvalid                      (c3_s0_axi_arvalid),
   .c3_s0_axi_arready                      (c3_s0_axi_arready),
   .c3_s0_axi_rid                          (c3_s0_axi_rid    ),
   .c3_s0_axi_rdata                        (c3_s0_axi_rdata  ),
   .c3_s0_axi_rresp                        (c3_s0_axi_rresp  ),
   .c3_s0_axi_rlast                        (c3_s0_axi_rlast  ),
   .c3_s0_axi_rvalid                       (c3_s0_axi_rvalid ),
   .c3_s0_axi_rready                       (c3_s0_axi_rready )
);

// INST_TAG_END ------ End INSTANTIATION Template ---------

// You must compile the wrapper file mig.v when simulating
// the core, mig. When compiling the wrapper file, be sure to
// reference the XilinxCoreLib Verilog simulation library. For detailed
// instructions, please refer to the "CORE Generator Help".

