----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:05:54 05/08/2013 
-- Design Name: 
-- Module Name:    top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

use work.txt_util.all;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity top is
	port( 
--		rst : in  std_logic;
--		aclk : in  std_logic; -- kommt vom PHY und hat einen Takt von 125MHz
		testpins_2 : out std_logic_vector(15 downto 0);
		testpins_3 : out std_logic_vector(3 downto 0);
		--switch : in std_logic;
		
		-- Ein- und Ausgnge um das Testmodul zu testen:
		m2_axis_video_tdata : out std_logic_vector(23 downto 0);
		m2_axis_video_tvalid : out std_logic;
		--m2_axis_video_tready : in std_logic;
		m2_axis_video_tuser : out std_logic;
		m2_axis_video_tlast : out std_logic;
		
		m2_axis_video_tstrb : out std_logic_vector(3 downto 0);
		m2_axis_video_tkeep : out std_logic_vector(3 downto 0);
		m2_axis_video_tid : out std_logic_vector(0 downto 0);
		m2_axis_video_tdest : out  std_logic_vector(0 downto 0);
		
		aclk2 : out std_logic;
		aclken2 : out std_logic;
		aresetn2 : out std_logic;


-- ----------------------------------------------------------------------------
		-- Signale von und zum RAM 
		c3_sys_clk : in std_logic;										-- das als Eingangstakt verwenden?
		c3_sys_rst_i : in std_logic;									-- als Reseteingang verwenden?
		c3_calib_done : out std_logic;								--
--		c3_clk0 : out std_logic;										-- 
--		c3_rst0 : out std_logic;										-- 

		mcb_rzq3 : inout std_logic;											--	fr die Input Kalibrierung (bei "Calibrated Input Termination" muss der Pin auf 2R zu GND,in allen ander Fllen soll er gelassen werden als no-connect pin)
		-- zio3 : inout std_logic;										-- fr die Input Kalibrierung; soll nicht verbunden werden; nur bei differential clock
		
		mcb3_dram_dq : inout std_logic_vector(15 downto 0);	-- Bidirektionaler Datenbus; Breite wird vom MIG tool gesetzt in Abhngigkeit des Speichers [C1_NUM_DQ_PINS-1:0]
		mcb3_dram_a : out std_logic_vector(13 downto 0);		-- Adress Bus; Adressbreite wird vom MIG tool gesetzt in Abhngigkeit des Speichers [C1_MEM_ADDR_WIDTH-1:0]
		mcb3_dram_ba : out std_logic_vector(2 downto 0);		-- Bank Adresse [C1_MEM_BANKADDR_WIDTH-1:0]
		mcb3_dram_ras_n : out std_logic;								-- Zeilenadresse
		mcb3_dram_cas_n : out std_logic;								-- active low Spaltenadressen Strobe
		mcb3_dram_we_n : out std_logic;								-- active low write enable
		mcb3_dram_odt : out std_logic;								-- on-die-termination signal ->???
		mcb3_dram_reset_n : out std_logic;							-- DDR3 reset
		mcb3_dram_cke : out std_logic;								-- active high clock enable
		mcb3_dram_dm : out std_logic;									-- Datenmaske fr das untere Datenbyte DQ(7:0)
		mcb3_dram_dqs : inout std_logic;								-- Bidirektionaler Datenstrobe fr DQ(7:0); input bei read und output bei write
		mcb3_dram_dqs_n : inout std_logic;							-- Bidirektionaler komplementrer Datenstrobe fr DQ(7:0); input bei read und output bei write
		mcb3_dram_udm : out std_logic;								-- Datenmaske fr das obere Datenbyte DQ(15:8)
		mcb3_dram_udqs : inout std_logic;							-- Bidirektionaler Datenstrobe fr DQ(15:8); input bei read und output bei write
		mcb3_dram_udqs_n : inout std_logic;							-- Bidirektionaler komplementrer Datenstrobe fr DQ(15:8); input bei read und output bei write
		mcb3_dram_ck : out std_logic;									-- differntial clock (p)
		mcb3_dram_ck_n : out std_logic;								--	differntial clock (n)
-- ----------------------------------------------------------------------------
		-- Status LEDs
		led_red : out  std_logic_vector(3 downto 0);
		led_green : out std_logic
	);
--	attribute buffer_sig : string;
--	attribute buffer_sig of clk : signal is "CLOCK_BUFFER";
--	attribute buffer_clk : string;
--	attribute buffer_clk of aclk : signal is "{bufgdll|ibufg|ibuf|bufr|none}";
	
end top;

architecture Behavioral of top is

	-- Virtual FIFO Controller
	--------------------------
	component vfifo
		port(
			------ Generelle Signale ---------------------------------------------
			aclk : in std_logic;											-- AXI clk fr Ein- und Ausgang
			aresetn : in std_logic; 									-- asynchroner reset (kommt aber synchron aus reset (intern sichergestellt))
			------ Signale zum MIG -----------------------------------------------
			-- write adress channel
			m_axi_awid : out std_logic_vector(0 downto 0); 		-- channel identifier (Ziel als Routing Information)
			m_axi_awaddr : out std_logic_vector(31 DOWNTO 0); 	-- Write Adresse (erste Adresse Burst Zyklus)
			m_axi_awlen : out std_logic_vector(7 DOWNTO 0);		-- Lnge des Burst Zyklus (genaue Anzahl)
			m_axi_awsize : out std_logic_vector(2 DOWNTO 0);	-- Burst Gre (gre jedes Transfers im Burstzyklus; hngt von der Datenbreite ab)
			m_axi_awburst : out std_logic_vector(1 DOWNTO 0);	-- Art des Burst; immer gesetzt auf inkrementierte Transfer
			m_axi_awlock : out std_logic_vector(0 DOWNTO 0);	-- Lock Type; immer 0
			m_axi_awcache : out std_logic_vector(3 DOWNTO 0);	-- Cache Typ; immer 0
			m_axi_awprot : out std_logic_vector(2 DOWNTO 0);	-- Protection type; immer 0
			m_axi_awqos : out std_logic_vector(3 DOWNTO 0);		-- Quality of Service; immer 0
			m_axi_awregion : out std_logic_vector(3 DOWNTO 0);	-- Region Identifier; immer 0
			m_axi_awuser : out std_logic_vector(0 DOWNTO 0);	-- Write Adress Channel User; immer 0
			m_axi_awvalid : out std_logic;							-- Write Adress Valid; Angabe, ob gltige Write Adress- und Kontrollinformationen verfgbar sind (1 = valid)
			m_axi_awready : in std_logic;								-- Write Adress Ready; zeigt an, ob der Slave bereit ist eine Adresse zu empfangen	
			-- write channel Signale
			m_axi_wdata : out std_logic_vector(31 DOWNTO 0);	-- Write Daten
			m_axi_wstrb : out std_logic_vector(3 DOWNTO 0);		-- Write Strobes; ??? (S.19)
			m_axi_wlast : out std_logic;								-- zeigt den letzten Transfer in einem Burst Zyklus an
			m_axi_wuser : out std_logic_vector(0 DOWNTO 0);		-- Write Data Channel User; immer 0
			m_axi_wvalid : out std_logic;								-- Write Valid; ob Lesedaten verfgbar sind (1 = Write-Daten und Strobes sind verfgbar)
			m_axi_wready : in std_logic;								-- Write Ready; ob Slave bereit ist Daten zu aktzeptieren (1 = Slave bereit)
			-- Write Response Channel Signale
			m_axi_bid : in std_logic_vector(0 DOWNTO 0);			-- Antwort ID...
			m_axi_bresp : in std_logic_vector(1 DOWNTO 0);		-- Write Response; Status des Schreibevorgangs (erlaubt sind: OKAY,EXOKAY,SLVERR,DECERR)
			m_axi_buser : in std_logic_vector(0 DOWNTO 0);		-- ungenutzt im VFIFO (Benutzersignal)
			m_axi_bvalid : in std_logic;								-- Write Response Valid - zeigt an, ob eine gltige Schreibantwort verfgbar ist
			m_axi_bready : out std_logic;								-- Response Ready - zeigt an, ob der Master die Anwort empfangen kann (1 = ready)
			-- Read Adress Channel Signale
			m_axi_arid : out std_logic_vector(0 DOWNTO 0);		-- Leseadress-ID (immer 0; alle konfigurierten Kanle haben Zugang zu einem einzelnen Adressbereich im Memory Map Interconnect...)
			m_axi_araddr : out std_logic_vector(31 DOWNTO 0);	-- Leseadresse (erste Adresse Burstzyklus)
			m_axi_arlen : out std_logic_vector(7 DOWNTO 0);		-- Burst Lnge (exakte Anzahl von Transferen in einem Burst)
			m_axi_arsize : out std_logic_vector(2 DOWNTO 0);	-- Burst Gre (Gre eines jeden Transfers im Burst; basierend auf Datenbreite des Interfaces)
			m_axi_arburst : out std_logic_vector(1 DOWNTO 0);	-- Burst Type (gekoppelt mit Greninformation, Details, wie jede Adressein einem Transfer zu adressieren ist,...)
			m_axi_arlock : out std_logic_vector(0 DOWNTO 0);	-- Lock Type; immer 0
			m_axi_arcache : out std_logic_vector(3 DOWNTO 0);	-- Cache Type; immer 0
			m_axi_arprot : out std_logic_vector(2 DOWNTO 0);	-- Protection Type; immer 0
			m_axi_arqos : out std_logic_vector(3 DOWNTO 0);		-- Quality of Service; immer 0
			m_axi_arregion : out std_logic_vector(3 DOWNTO 0);	-- Region Indentifier; immer 0
			m_axi_aruser : out std_logic_vector(0 DOWNTO 0);	-- Read Adress Channel User; immer 0
			m_axi_arvalid : out std_logic;							-- Read Adress Valid; Angabe, ob gltige Read Adress- und Kontrollinformationen verfgbar sind (1 = valid)
			m_axi_arready : in std_logic;								-- Read Adress Ready; zeigt an, ob der Slave bereit ist Adress- und zugehrige Kontrollinformation zu empfangen (1 = ready)
			-- Read Data Channel Signale
			m_axi_rid : in std_logic_vector(0 DOWNTO 0);			-- Read ID Tag; ...; erzeugt im Slave; nicht genutzt im VFIFO
			m_axi_rdata : in std_logic_vector(31 DOWNTO 0);		-- Read Data
			m_axi_rresp : in std_logic_vector(1 DOWNTO 0);		-- Read Response; zeigt den Status des Lesetransfers an (erlaubt sind: OKAY,EXOKAY,SLVERR,DECERR)
			m_axi_rlast : in std_logic;								-- Read Last; letzter Transfer in einem Leseburst
			m_axi_ruser : in std_logic_vector(0 DOWNTO 0);		-- wird im VFIFO nicht benutzt (wahrscheinlich einfach weitergeleitet?)
			m_axi_rvalid : in std_logic;								-- Lesedaten verfgbar (1 = Daten verfgbar)
			m_axi_rready : out std_logic;								-- ob Master bereit ist die Lesedaten und Antwortinformationen zu bekommen (ready = 1)
			------ Verbindung zu den Ein- und Ausgngen --------------------------
			-- AXI4 Stream Slave (in)
			s_axis_tvalid : in std_logic;								-- Handshake Signal
			s_axis_tready : out std_logic;							-- Handshake Signal
			s_axis_tdata : in std_logic_vector(31 DOWNTO 0);	-- Daten
			s_axis_tstrb : in std_logic_vector(3 DOWNTO 0); 	-- ??? zeigt an ob dazugehriger Inhalt Datenbyte oder Positionsbyte ist -> nicht benutzt im VFIFO, wird anscheinend nur durchgeschliffen
			s_axis_tkeep : in std_logic_vector(3 DOWNTO 0);  	-- zeigt (in Bytepaaren) an, welche Bytes Daten enthalten (in diesem Fall immer gleich: 0x7 = 0b0111)
			s_axis_tlast : in std_logic;							 	-- EOL
			s_axis_tid : in std_logic_vector(0 DOWNTO 0);    	-- ID des Streams; gibt Quell ID an; immer beliebig aber gleich mit Ausgang bzw vllig wurscht
			s_axis_tdest : in std_logic_vector(0 DOWNTO 0);  	-- Destination Identifier, der angibt, wo hin der Stream geroutet werden soll (nicht bentigt)
			s_axis_tuser : in std_logic_vector(0 DOWNTO 0);  	-- SOF (Inhalt wird vom Benutzer festgelegt, muss aber mit einem Datensatz gleichzeitig kommen - hier schon getan)
			-- AXI4 Stream Master (out)
			m_axis_tvalid : out std_logic;						 	-- Handshake Signal
			m_axis_tready : in std_logic;							 	-- Handshake Signal
			m_axis_tdata : out std_logic_vector(31 DOWNTO 0);	-- Daten
			m_axis_tstrb : out std_logic_vector(3 DOWNTO 0); 	-- siehe ^
			m_axis_tkeep : out std_logic_vector(3 DOWNTO 0); 	-- siehe ^
			m_axis_tlast : out std_logic;							 	-- EOL
			m_axis_tid : out std_logic_vector(0 DOWNTO 0);   	-- siehe ^S
			m_axis_tdest : out std_logic_vector(0 DOWNTO 0); 	-- Destination Identifier, der angibt, wo hin der Stream geroutet werden soll (nicht bentigt)
			m_axis_tuser : out std_logic_vector(0 DOWNTO 0); 	-- SOF	-> "sideband information that can be transmitted alongside the data stream" (S.38)
			------ Kontrollsignale -----------------------------------------------
			vfifo_mm2s_channel_full : in std_logic_vector(1 DOWNTO 0);   -- channel full flag
			vfifo_s2mm_channel_full : out std_logic_vector(1 DOWNTO 0);  -- channel full flag
			vfifo_mm2s_channel_empty : out std_logic_vector(1 DOWNTO 0); -- channel empty flag
			vfifo_idle : out std_logic_vector(1 DOWNTO 0)	 				 -- Zeigt an, ob der VFIFO eine anstehende Aufgabe hat???
		);
	end component;

	-- MIG interface
	----------------------------------------------------------------------------
		-- ohne MIG lsst sich ein Programming File erzeugen
		-- mit Komponentendeklaration auch (was nichts heien muss)
	component mig 
		generic (
			DEBUG_EN : integer := 0;								-- 1 = enable debug signals/controls
			--
			C3_P0_MASK_SIZE : integer := 4;						-- 
			C3_P0_DATA_PORT_SIZE : integer := 32;				-- 
			C3_P1_MASK_SIZE : integer := 4;						-- 
			C3_P1_DATA_PORT_SIZE : integer := 32;				-- 
			--
			C3_MEMCLK_PERIOD : integer := 3000;					-- memory data transfer clock period; Dieses Attribut konvertiert die Speicher timing parameter zwischen Tykt Zyklen und Picosekunden
			C3_CALIB_SOFT_IP : string := "FALSE";				-- TRUE = enables the soft calibration logic, FALSE disables
			C3_SIMULATION : string := "TRUE";					-- TRUE = simulating the design, usefull to reduce simulation time, FALSE = implementing the design
			C3_RST_ACT_LOW : integer := 0;						-- 1 for active low reset, 0 for aactive high reset
			C3_INPUT_CLK_TYPE : string := "SINGLE_ENDED";	-- Art der Input Clock; DIFFERENTIAL ir SINGLE_ENDED
			C3_MEM_ADDR_ORDER : string := "ROW_BANK_COLUMN";-- UG388 S.24
			C3_NUM_DQ_PINS : integer := 16;						-- Bitbreite DQ Bus
			C3_MEM_ADDR_WIDTH : integer := 14;					-- Speicheradressbusbreite
			C3_MEM_BANKADDR_WIDTH : integer := 3;				-- Bankadressbreite
			-- UG416 ab S.63
			C3_S0_AXI_STRICT_COHERENCY : integer := 0;		-- Delays B channel response until it can be guaranteed the write has been commited to memory. Required when accessing the same address between different ports.
			C3_S0_AXI_ENABLE_AP : integer := 0;					-- Enables Auto Precharge in each transaction sent to the memory controller
			C3_S0_AXI_DATA_WIDTH : integer := 32;				-- AXI Datenbreite
			C3_S0_AXI_SUPPORTS_NARROW_BURST : integer := 1;	-- Enables logic to support narrow transfers over MCB. Required if the slave receives transactions smaller than the AXI/MCB native data width.
			C3_S0_AXI_ADDR_WIDTH : integer := 32;				-- AXI Adressbreite
			C3_S0_AXI_ID_WIDTH : integer := 1					-- AXI ID Breite
		);
		port (
			-- Signale zum Speicher (UG388 S.30-31); momentan nur ein Speicher angeschlossen (sonst doppelte Menge an Signalen)
			mcb3_dram_dq : inout std_logic_vector(C3_NUM_DQ_PINS-1 downto 0);			-- Bidirektionaler Datenbus; Breite wird vom MIG tool gesetzt in Abhngigkeit des Speichers
			mcb3_dram_a : out std_logic_vector(C3_MEM_ADDR_WIDTH-1 downto 0);			-- Adress Bus; Adressbreite wird vom MIG tool gesetzt in Abhngigkeit des Speichers
			mcb3_dram_ba : out std_logic_vector(C3_MEM_BANKADDR_WIDTH-1 downto 0);	-- Bank Adresse [2:0]
			mcb3_dram_ras_n : out std_logic;											-- Zeilenadresse
			mcb3_dram_cas_n : out std_logic;											-- active low Spaltenadressen Strobe
			mcb3_dram_we_n : out std_logic;											-- active low write enable
			mcb3_dram_odt : out std_logic;											-- on-die-termination signal ->???
			mcb3_dram_reset_n : out std_logic;										-- DDR3 reset
			mcb3_dram_cke : out std_logic;											-- active high clock enable
			mcb3_dram_dm : out std_logic;												-- Datenmaske fr das untere Datenbyte DQ(7:0)
			mcb3_dram_dqs : inout std_logic;											-- Bidirektionaler Datenstrobe fr DQ(7:0); input bei read und output bei write
			mcb3_dram_dqs_n : inout std_logic;										-- Bidirektionaler komplementrer Datenstrobe fr DQ(7:0); input bei read und output bei write
			mcb3_dram_udm : out std_logic;											-- Datenmaske fr das obere Datenbyte DQ(15:8)
			mcb3_dram_udqs : inout std_logic;										-- Bidirektionaler Datenstrobe fr DQ(15:8); input bei read und output bei write
			mcb3_dram_udqs_n : inout std_logic;										-- Bidirektionaler komplementrer Datenstrobe fr DQ(15:8); input bei read und output bei write
			mcb3_dram_ck : out std_logic;												-- differntial clock (p)
			mcb3_dram_ck_n : out std_logic;											--	differntial clock (n)		
			mcb3_rzq : inout std_logic;												--	fr die Input Kalibrierung (bei "Calibrated Input Termination" muss der Pin auf 2R zu GND,in allen ander Fllen soll er gelassen werden als no-connect pin)
			-----------------------------
			--	Kalibrierung und Clock (Informationen aus dem Xilinx Forum: http://forums.xilinx.com/t5/MIG-Memory-Interface-Generator/Unknown-inputs-outputs-of-MIG/m-p/318543)
			c3_sys_clk : in std_logic;													-- is the clock input pin to the FPGA.  This is not really part of the MIG design itself
																								-- but feeds the PLL or DCM that generates the internal timing.  If you don't have a dedicated
																								-- clock pin, you can edit the infrastructure code to remove the clock input buffer and then
																								-- feed an existing internal clock signal to this net.
			c3_sys_rst_i : in std_logic;												-- is the reset input to the core.  Follow this into the infrastructure module where
																								-- it will be ORed with PLL or DCM locked signals to produce c3_rst0
			c3_calib_done : out std_logic;											-- (= phy_init_done); '1' wenn Kalibrierung abgeschlossen (vorher ist der Speicher nicht nutzbar)
			c3_clk0 : out std_logic;													-- is derived from the sys_clk input using a PLL or DCM and can be used to drive system
																								-- logic.  You may need to adjust the multiply/divide settings to get the correct frequency out.
			c3_rst0 : out std_logic;													-- anscheinend ebenfalls System Reset
			----------------------------- Read Channel											-- (aus UG586 ab S.69)

			c3_s0_axi_aclk : in std_logic;															-- Takt
			c3_s0_axi_aresetn : in std_logic;														-- Reset des AXI Moduls
			c3_s0_axi_awid : in std_logic_vector(C3_S0_AXI_ID_WIDTH - 1 downto 0);		-- Write Adress ID
			c3_s0_axi_awaddr : in std_logic_vector(C3_S0_AXI_ADDR_WIDTH - 1 downto 0);	-- Write Adress
			c3_s0_axi_awlen : in std_logic_vector(7 downto 0);									-- Burst length; exakte Anzahl von Transferen in einem Burst
			c3_s0_axi_awsize : in std_logic_vector(2 downto 0);								-- Burst Size; Gre jedes Transfers in einem Burst
			c3_s0_axi_awburst : in std_logic_vector(1 downto 0);								-- Burst Type
			c3_s0_axi_awlock : in std_logic_vector(0 downto 0);								-- Lock Type (nicht verwendet)
			c3_s0_axi_awcache : in std_logic_vector(3 downto 0);								-- Cache Type (nicht verwendet)
			c3_s0_axi_awprot : in std_logic_vector(2 downto 0);								-- Protection Type (nicht verwendet)
			c3_s0_axi_awqos : in std_logic_vector(3 downto 0);									-- Quality of Service; nicht umgesetzt (UG761 S.149); in Simulation immer 'Z'
			c3_s0_axi_awvalid : in std_logic;														-- Write Adress Valid; zeigt an, dass gltige Schreibeadresse und Kontrollinformation verfgbar ist 
			c3_s0_axi_awready : out std_logic;														-- Write Adress Ready; zeigt an, ob der Slave bereit ist eine Adresse und zugehrige Kontrollsignale zu empfangen

			c3_s0_axi_wdata : in std_logic_vector(C3_S0_AXI_DATA_WIDTH - 1 downto 0);	-- Write Data
			c3_s0_axi_wstrb : in std_logic_vector(C3_S0_AXI_DATA_WIDTH/8 - 1 downto 0);-- Write Strobes
			c3_s0_axi_wlast : in std_logic;															-- Write Last; letzter Transfer in einem Burst
			c3_s0_axi_wvalid : in std_logic;															-- Write Valid; Schreibedaten und Strobe sind verfgbar
			c3_s0_axi_wready : out std_logic;	
			-- Write Ready
			c3_s0_axi_bid : out std_logic_vector(C3_S0_AXI_ID_WIDTH - 1 downto 0);		-- Response ID; identification tag of the write response
			c3_s0_axi_wid : out std_logic_vector(C3_S0_AXI_ID_WIDTH - 1 downto 0);		-- Write ID tag??? this signal is the ID tag of the write data transfer. The WID value must match the AWID value of tehe write transaction (PG057)
			c3_s0_axi_bresp : out std_logic_vector(1 downto 0);								-- Write Response; Status der Schreibeantwort
			c3_s0_axi_bvalid : out std_logic;														-- Write Response Valid
			c3_s0_axi_bready : in std_logic;															-- Response Ready
			
			c3_s0_axi_arid : in std_logic_vector(C3_S0_AXI_ID_WIDTH - 1 downto 0);		-- Read Adress ID
			c3_s0_axi_araddr : in std_logic_vector(C3_S0_AXI_ADDR_WIDTH - 1 downto 0);	-- Read Adress
			c3_s0_axi_arlen : in std_logic_vector(7 downto 0);									-- Read burst length
			c3_s0_axi_arsize : in std_logic_vector(2 downto 0);								-- Read Burst size
			c3_s0_axi_arburst : in std_logic_vector(1 downto 0);								-- Read Burst Type
			c3_s0_axi_arlock : in std_logic_vector(0 downto 0);								-- Lock type (nicht verwendet)
			c3_s0_axi_arcache : in std_logic_vector(3 downto 0);								-- Cache type (nicht verwendet)
			c3_s0_axi_arprot : in std_logic_vector(2 downto 0);								-- Protection type (nicht verwendet)
			c3_s0_axi_arqos : in std_logic_vector(3 downto 0);									-- Quality of Service; nicht umgesetzt? (UG761 S.152)
			c3_s0_axi_arvalid : in std_logic;														-- Read Adress valid
			c3_s0_axi_arready : out std_logic;														-- Read Adress ready
			
			c3_s0_axi_rid : out std_logic_vector(C3_S0_AXI_ID_WIDTH - 1 downto 0);		-- Read ID tag
			c3_s0_axi_rdata : out std_logic_vector(C3_S0_AXI_DATA_WIDTH - 1 downto 0);	-- Read Data
			c3_s0_axi_rresp : out std_logic_vector(1 downto 0);								-- Read Response
			c3_s0_axi_rlast : out std_logic;															-- Read last
			c3_s0_axi_rvalid : out std_logic;														-- Read valid
			c3_s0_axi_rready : in std_logic															-- Read Ready
		);
	end component;

	-- --------------------------------------------
	-- Signale fr den AXI Stream und Clock Signale
	-- --------------------------------------------
	signal aclk : std_logic;
	signal aclken : std_logic := '0';
	signal aresetn : std_logic;
	signal rst : std_logic := '0';
	-- ------------------------
	-- Signale fr den Video_in
	-- ------------------------
	signal m_axis_video_tdata : std_logic_vector(23 downto 0) := (others => '0');
	signal m_axis_video_tvalid : std_logic := '0';
	signal m_axis_video_tready : std_logic := '0';
	signal m_axis_video_tuser : std_logic := '0';
	signal m_axis_video_tlast : std_logic := '0';
	
	signal m_axis_video_tstrb : std_logic_vector(3 downto 0) := "0000";  -- ??? zeigt an ob dazugehriger Inhalt Datenbyte oder Positionsbyte ist -> nicht benutzt im VFIFO, wird anscheinend nur durchgeschliffen
	signal m_axis_video_tkeep : std_logic_vector(3 downto 0) := "0000";  -- zeigt (in Bytepaaren) an, welche Bytes Daten enthalten (in diesem Fall immer gleich: 0x7 = 0b0111)
	signal m_axis_video_tid : std_logic_vector(0 downto 0) := "0";    	-- ID des Streams; gibt Quell ID an; immer beliebig aber gleich mit Ausgang bzw vllig wurscht
	signal m_axis_video_tdest : std_logic_vector(0 downto 0) := "0";  	-- Destination Identifier, der angibt, wo hin der Stream geroutet werden soll (nicht bentigt)

	-- ---------------------
	-- Signale fr den VFIFO
	-- ---------------------
	-- zustzliches Signal fr den VFIFO um die Busbreite aufzustocken
	signal nullsignal : std_logic_vector(7 downto 0) := "00000000"; 	-- zum Auffllen der Busbreite
	------ Signale zum MIG ----------------------------------------------------- (wire)
	-- write adress channel
	signal m_axi_awid : std_logic_vector(0 downto 0); 						-- Channel Identifier (Ziel als Routing Information)
	signal m_axi_awaddr : std_logic_vector(31 downto 0); 					-- Write Adresse (erste Adresse Burst Zyklus)
	signal m_axi_awlen : std_logic_vector(7 downto 0);						-- Lnge des Burst Zyklus (genaue Anzahl)
	signal m_axi_awsize : std_logic_vector(2 downto 0);					-- Burst Gre (gre jedes Transfers im Burstzyklus; hngt von der Datenbreite ab)
	signal m_axi_awburst : std_logic_vector(1 downto 0);					-- Art des Burst; immer gesetzt auf inkrementierte Transfer
	signal m_axi_awlock : std_logic_vector(0 downto 0) := "0";			-- Lock Type; immer 0
	signal m_axi_awcache : std_logic_vector(3 downto 0) := "0000";		-- Cache Typ; immer 0
	signal m_axi_awprot : std_logic_vector(2 downto 0) := "000";		-- Protection type; immer 0
	signal m_axi_awqos : std_logic_vector(3 downto 0) := "0000";		-- Quality of Service; immer 0
	signal m_axi_awregion : std_logic_vector(3 downto 0) := "0000";	-- Region Identifier; immer 0
	signal m_axi_awuser : std_logic_vector(0 downto 0) := "0";			-- Write Adress Channel User; immer 0
	signal m_axi_awvalid : std_logic;											-- Write Adress Valid; Angabe, ob gltige Write Adress- und Kontrollinformationen verfgbar sind (1 = valid)
	signal m_axi_awready : std_logic;											-- Write Adress Ready; zeigt an, ob der Slave bereit ist eine Adresse zu empfangen
	-- write channel Signale
	signal m_axi_wdata : std_logic_vector(31 downto 0);					-- Write Daten
	signal m_axi_wstrb : std_logic_vector(3 downto 0);						-- Write Strobes; ??? (S.19)
	signal m_axi_wlast : std_logic;												-- zeigt den letzten Transfer in einem Burst Zyklus an
	signal m_axi_wuser : std_logic_vector(0 downto 0) := "0";			-- Write Data Channel User; immer 0
	signal m_axi_wvalid : std_logic;												-- Write Valid; ob Lesedaten verfgbar sind (1 = Write-Daten und Strobes sind verfgbar)
	signal m_axi_wready : std_logic;												-- Write Ready; ob Slave bereit ist Daten zu aktzeptieren (1 = Slave bereit)
	-- Write Response Channel Signale
	signal m_axi_bid : std_logic_vector(0 downto 0);						-- Antwort ID...
	signal m_axi_bresp : std_logic_vector(1 downto 0);						-- Write Response; Status des Schreibevorgangs (erlaubt sind: OKAY,EXOKAY,SLVERR,DECERR)
	signal m_axi_buser : std_logic_vector(0 downto 0) := "0";			-- ungenutzt im VFIFO (Benutzersignal)
	signal m_axi_bvalid : std_logic;												-- Write Response Valid - zeigt an, ob eine gltige Schreibantwort verfgbar ist
	signal m_axi_bready : std_logic;												-- Response Ready - zeigt an, ob der Master die Anwort empfangen kann (1 = ready)
	-- Read Adress Channel Signale
	signal m_axi_arid : std_logic_vector(0 downto 0);						-- Leseadress-ID (immer 0; alle konfigurierten Kanle haben Zugang zu einem einzelnen Adressbereich im Memory Map Interconnect...)
	signal m_axi_araddr : std_logic_vector(31 downto 0);					-- Leseadresse (erste Adresse Burstzyklus)
	signal m_axi_arlen : std_logic_vector(7 downto 0);						-- Burst Lnge (exakte Anzahl von Transferen in einem Burst)
	signal m_axi_arsize : std_logic_vector(2 downto 0);					-- Burst Gre (Gre eines jeden Transfers im Burst; basierend auf Datenbreite des Interfaces)
	signal m_axi_arburst : std_logic_vector(1 downto 0);					-- Burst Type (gekoppelt mit Greninformation, Details, wie jede Adressein einem Transfer zu adressieren ist,...)
	signal m_axi_arlock : std_logic_vector(0 downto 0) := "0";			-- Lock Type; immer 0
	signal m_axi_arcache : std_logic_vector(3 downto 0) := "0000";		-- Cache Type; immer 0
	signal m_axi_arprot : std_logic_vector(2 downto 0) := "000";		-- Protection Type; immer 0
	signal m_axi_arqos : std_logic_vector(3 downto 0) := "0000";		-- Quality of Service; immer 0
	signal m_axi_arregion : std_logic_vector(3 downto 0) := "0000";	-- Region Indentifier; immer 0
	signal m_axi_aruser : std_logic_vector(0 downto 0) := "0";			-- Read Adress Channel User; immer 0
	signal m_axi_arvalid : std_logic;											-- Read Adress Valid; Angabe, ob gltige Read Adress- und Kontrollinformationen verfgbar sind (1 = valid)
	signal m_axi_arready : std_logic;											-- Read Adress Ready; zeigt an, ob der Slave bereit ist Adress- und zugehrige Kontrollinformation zu empfangen (1 = ready)
	-- Read Data Channel Signale
	signal m_axi_rid : std_logic_vector(0 downto 0) := "0";				-- Read ID Tag; ...; erzeugt im Slave; nicht genutzt im VFIFO
	signal m_axi_rdata : std_logic_vector(31 downto 0);					-- Read Data
	signal m_axi_rresp : std_logic_vector(1 downto 0);						-- Read Response; zeigt den Status des Lesetransfers an (erlaubt sind: OKAY,EXOKAY,SLVERR,DECERR)
	signal m_axi_rlast : std_logic;												-- Read Last; letzter Transfer in einem Leseburst
	signal m_axi_ruser : std_logic_vector(0 downto 0) := "0";			-- wird im VFIFO nicht benutzt (wahrscheinlich einfach weitergeleitet?)
	signal m_axi_rvalid : std_logic;												-- Lesedaten verfgbar (1 = Daten verfgbar)
	signal m_axi_rready : std_logic;												-- ob Master bereit ist die Lesedaten und Antwortinformationen zu bekommen (ready = 1)
	------ Verbindung zu den Ein- und Ausgngen --------------------------------
	-- AXI4 Stream Slave (in) -> teilweise nicht bentigt, da ja schon als Ausgangssignale vom vid_in verfgbar 
--	signal s_axis_tvalid : std_logic;							 				-- Handshake Signal
--	signal s_axis_tready : std_logic;						 					-- Handshake Signal
--	signal s_axis_tdata : std_logic_vector(31 downto 0); 					-- Daten
--	signal s_axis_tstrb : std_logic_vector(3 downto 0) := "0000";  	-- ??? zeigt an ob dazugehriger Inhalt Datenbyte oder Positionsbyte ist -> nicht benutzt im VFIFO, wird anscheinend nur durchgeschliffen
--	signal s_axis_tkeep : std_logic_vector(3 downto 0) := "0000";  	-- zeigt (in Bytepaaren) an, welche Bytes Daten enthalten (in diesem Fall immer gleich: 0x7 = 0b0111)
--	signal s_axis_tlast : std_logic;							 					-- EOL
--	signal s_axis_tid : std_logic_vector(0 downto 0) := "0";    		-- ID des Streams; gibt Quell ID an; immer beliebig aber gleich mit Ausgang bzw vllig wurscht
--	signal s_axis_tdest : std_logic_vector(0 downto 0) := "0";  		-- Destination Identifier, der angibt, wo hin der Stream geroutet werden soll (nicht bentigt)
--	signal s_axis_tuser : std_logic_vector(0 downto 0);  					-- SOF (Inhalt wird vom Benutzer festgelegt, muss aber mit einem Datensatz gleichzeitig kommen - hier schon getan)

	-- AXI4 Stream Master (out)	-> hier ber Testumgebung definiert (m3_axis_video_...)
--	signal m_axis_buffered_tvalid : std_logic;						 		-- Handshake Signal
--	signal m_axis_buffered_tready : std_logic;								-- Handshake Signal
--	signal m_axis_buffered_tdata : std_logic_vector(23 downto 0);		-- Daten
--	signal m_axis_tstrb : std_logic_vector(3 downto 0) := "0000"; 		-- siehe ^
--	signal m_axis_tkeep : std_logic_vector(3 downto 0) := "0000";		-- siehe ^
--	signal m_axis_buffered_tlast : std_logic;									-- EOL
--	signal m_axis_tid : std_logic_vector(0 downto 0) := "0";   			-- siehe ^S
--	signal m_axis_tdest : std_logic_vector(0 downto 0) := "0"; 			-- ???
--	signal m_axis_buffered_tuser : std_logic; 								-- SOF

	signal m3_axis_video_tdata : std_logic_vector(23 downto 0);
	signal m3_axis_video_tvalid : std_logic;
	signal m3_axis_video_tready : std_logic;
	signal m3_axis_video_tuser : std_logic;
	signal m3_axis_video_tlast : std_logic;
	
	signal m3_axis_video_tstrb : std_logic_vector(3 downto 0);
	signal m3_axis_video_tkeep : std_logic_vector(3 downto 0);
	signal m3_axis_video_tid : std_logic_vector(0 downto 0);
	signal m3_axis_video_tdest : std_logic_vector(0 downto 0);

	
	------ Kontrollsignale -----------------------------------------------------
	signal vfifo_mm2s_channel_full : std_logic_vector(1 downto 0); 	-- channel full flag
	signal vfifo_s2mm_channel_full : std_logic_vector(1 downto 0); 	-- channel full flag
	signal vfifo_mm2s_channel_empty : std_logic_vector(1 downto 0);	-- channel empty flag
	signal vfifo_idle : std_logic_vector(1 downto 0);	 					-- Zeigt an, ob der VFIFO eine anstehende Aufgabe hat???

	-- ---------------
	-- Signale vom MIG
	-- ---------------
--	signal c3_sys_clk : std_logic;												-- 
--	signal c3_sys_rst_i : std_logic;												--
--	signal c3_calib_done : std_logic;											--
--	signal c3_clk0 : std_logic;													--
--	signal c3_rst0 : std_logic;													--
	signal c3_s0_axi_aclk : std_logic;
	signal m_axi_wid : std_logic_vector(0 downto 0) := "0";				-- nur bergangsweise - das Signal fehlt beim VFIFO irgendwie zur Verindung mit dem MIG

	-- ----------------
	-- Sonstige Signale
	-- ----------------
	-- Eingangsseitige Stimulierung
	type state_type is (STREAM_BEREIT, DATEN_1, DATEN_2, DATEN_3, DATEN_4, FERTIG);
	signal state : state_type := STREAM_BEREIT;

	-- Ausgangsseitiges berprfen
	type state_read_type is (STREAM_BEREIT, DATEN_1, DATEN_2, DATEN_3, DATEN_4, FERTIG);
	signal state_read : state_read_type := STREAM_BEREIT;
	
	signal data_pruefung : std_logic_vector(15 downto 0) := (others => '0');
	signal status_pruefung : std_logic_vector(3 downto 0) := (others => '0');
	
	----------------------------------------------------------------------------
	-- Konstanten
	----------------------------------------------------------------------------
	constant daten_1_1 : std_logic_vector(7 downto 0) := "00000001";
	constant daten_1_2 : std_logic_vector(7 downto 0) := "00000010";
	constant daten_1_3 : std_logic_vector(7 downto 0) := "00000100";
	constant daten_2_1 : std_logic_vector(7 downto 0) := "00001000";
	constant daten_2_2 : std_logic_vector(7 downto 0) := "00010000";
	constant daten_2_3 : std_logic_vector(7 downto 0) := "00100000";
	constant daten_3_1 : std_logic_vector(7 downto 0) := "01000000";
	constant daten_3_2 : std_logic_vector(7 downto 0) := "10000000";
	constant daten_3_3 : std_logic_vector(7 downto 0) := "00000000";
	constant daten_4_1 : std_logic_vector(7 downto 0) := "11111111";
	constant daten_4_2 : std_logic_vector(7 downto 0) := "11111111";
	constant daten_4_3 : std_logic_vector(7 downto 0) := "11111111";
	
	constant tdest : std_logic_vector(0 downto 0) := "0";
	constant tid : std_logic_vector(0 downto 0) := "0";
	constant tkeep : std_logic_vector(3 downto 0) := "1111";
	constant tstrb : std_logic_vector(3 downto 0) := "0000";
	
begin
	--c3_sys_clk <= aclk;
	aresetn <= not rst;
--	m_axis_video_tready <= m2_axis_video_tready; -- wird verbunden ber den VFIFO, darf daher nicht auch noch mit einem Eingang verbunden werden
	
	-- funktioniert und stimmt soweit (4 Daten pro "Zeile", 1 "Zeile" pro "Bild")
	-- Bedingung, damit keine Daten verloren gehen: tready muss im Takt geschaltet werden!
	Signalerzeugung : process (aclk, rst)
	begin
		if rising_edge(aclk) then		-- "andere" Clock zur berprfung der Clocks 
			if rst = '1' then
				m_axis_video_tdata <= (others => '0');
				m_axis_video_tvalid <= '0';
				m_axis_video_tuser <= '0';
				m_axis_video_tlast <= '0';
				
				m_axis_video_tstrb <= "0000";	-- zeigt an ob dazugehriger Inhalt Datenbyte oder Positionsbyte ist
				m_axis_video_tkeep <= "0000";
				m_axis_video_tid <= "0";
				m_axis_video_tdest <= "0";
				
				aclken <= '0';		-- wird bisher nicht genutzt
				
				state <= STREAM_BEREIT;
				
			else -- spter so, dass bei jedem Schalterdrcken ein Datenpaket eingespeichert wird?
				-- INTEGRIEREN VON calib_done (vorher nicht anfangen zu lesen oder zu schreiben)!!!
				aclken <= '1';
				-- Beginn Signalaufbau; senden von 4 Datenstrmen
				case state is
					when STREAM_BEREIT => if m_axis_video_tready = '1' then		-- ob tready gesetzt ist (ob Slave bereit ist Daten zu empfangen)
													state <= DATEN_1;							-- hier kann ggf. noch eine weitere Option eingebaut werden
												 end if;
					when DATEN_1 =>	if m_axis_video_tready = '1' then
												m_axis_video_tdata(7 downto 0) <= daten_1_1;
												m_axis_video_tdata(15 downto 8) <= daten_1_2;
												m_axis_video_tdata(23 downto 16) <= daten_1_3;
												m_axis_video_tvalid <= '1';
												m_axis_video_tuser <= '1'; -- SOF
												m_axis_video_tlast <= '0'; -- EOL
												-- weitere signale
												m_axis_video_tstrb <= tstrb;
												m_axis_video_tkeep <= tkeep;
												m_axis_video_tid <= tid;
												m_axis_video_tdest <= tdest;
												--
												state <= DATEN_2;
											end if;
					when DATEN_2 =>	if m_axis_video_tready = '1' then	
												m_axis_video_tdata(7 downto 0) <= daten_2_1;
												m_axis_video_tdata(15 downto 8) <= daten_2_2;
												m_axis_video_tdata(23 downto 16) <= daten_2_3;
												m_axis_video_tvalid <= '1';
												m_axis_video_tuser <= '0'; -- SOF
												m_axis_video_tlast <= '0'; -- EOL
												-- weitere signale
												m_axis_video_tstrb <= tstrb;
												m_axis_video_tkeep <= tkeep;
												m_axis_video_tid <= tid;
												m_axis_video_tdest <= tdest;
												--
												state <= DATEN_3;
											end if;
					when DATEN_3 =>	if m_axis_video_tready = '1' then
												m_axis_video_tdata(7 downto 0) <= daten_3_1;
												m_axis_video_tdata(15 downto 8) <= daten_3_2;
												m_axis_video_tdata(23 downto 16) <= daten_3_3;
												m_axis_video_tvalid <= '1';
												m_axis_video_tuser <= '0'; -- SOF
												m_axis_video_tlast <= '0'; -- EOL
												-- weitere signale
												m_axis_video_tstrb <= tstrb;
												m_axis_video_tkeep <= tkeep;
												m_axis_video_tid <= tid;
												m_axis_video_tdest <= tdest;
												--
												state <= DATEN_4;
											end if;
					when DATEN_4 =>	if m_axis_video_tready = '1' then
												m_axis_video_tdata(7 downto 0) <= daten_4_1;
												m_axis_video_tdata(15 downto 8) <= daten_4_2;
												m_axis_video_tdata(23 downto 16) <= daten_4_3;
												m_axis_video_tvalid <= '1';
												m_axis_video_tuser <= '0'; -- SOF
												m_axis_video_tlast <= '1'; -- EOL
												-- weitere signale
												m_axis_video_tstrb <= tstrb;
												m_axis_video_tkeep <= tkeep;
												m_axis_video_tid <= tid;
												m_axis_video_tdest <= tdest;
												--
												state <= FERTIG;
											end if;
					when FERTIG =>		if m_axis_video_tready = '1' then
												m_axis_video_tdata(7 downto 0) <= "00000000";
												m_axis_video_tdata(15 downto 8) <= "00000000";
												m_axis_video_tdata(23 downto 16) <= "00000000";
												m_axis_video_tvalid <= '0';
												m_axis_video_tuser <= '0'; -- SOF
												m_axis_video_tlast <= '0'; -- EOL
												-- weitere signale
												m_axis_video_tstrb <= "0000";
												m_axis_video_tkeep <= "0000";
												m_axis_video_tid <= "0";
												m_axis_video_tdest <= "0";
												--
												state <= STREAM_BEREIT;
											end if;
					when others =>		state <= STREAM_BEREIT;
											--m_axis_video_tvalid <= '0';
				end case;
			end if;
		end if;
	end process;

	-- Auf den Simulationsausgang das gleiche legen wie auf den VFIFO (wird spter auskommentiert)
--	m2_axis_video_tdata <= m_axis_video_tdata;
--	m2_axis_video_tvalid <= m_axis_video_tvalid;
--	m2_axis_video_tuser <= m_axis_video_tuser;
--	m2_axis_video_tlast <= m_axis_video_tlast;
--
--	m2_axis_video_tstrb <= m_axis_video_tstrb;
--	m2_axis_video_tkeep <= m_axis_video_tkeep;
--	m2_axis_video_tid <= m_axis_video_tid;
--	m2_axis_video_tdest <= m_axis_video_tdest;
--				
--	aclk2 <= aclk;
--	aclken2 <= aclken;
--	aresetn2 <= aresetn;

	Auslesen_der_Daten : process(aclk)
	begin
		if rising_edge(aclk) then
			if rst = '1' then
				-- alles zurcksetzen				
				data_pruefung <= (others => '0');
				status_pruefung <= (others => '0');
				state_read <= STREAM_BEREIT;
				m3_axis_video_tready <= '0';
			else
				-- Daten lesen und entsprechend den Status setzen (ob an richtiger Stelle)
				-- (nicht abgesichert und getestet: Daten in falscher Reihenfolge)
				if state_read = STREAM_BEREIT then
					m3_axis_video_tready <= '0';
					data_pruefung <= (others => '0');
					status_pruefung <= (others => '0');
					state_read <= DATEN_1;
				else
					m3_axis_video_tready <= '1';
						
					if m3_axis_video_tvalid = '1' then
						if ((m3_axis_video_tdata(7 downto 0) = daten_1_1) 
								and (m3_axis_video_tdata(15 downto 8) = daten_1_2)
								and (m3_axis_video_tdata(23 downto 16) = daten_1_3)) then
							data_pruefung(3 downto 0) <= "1111";
							if (state_read = DATEN_1) then
								state_read <= DATEN_2;
								if ((m3_axis_video_tuser = '1') and (m3_axis_video_tlast = '0')
										and (m3_axis_video_tstrb = tstrb) and (m3_axis_video_tkeep = tkeep) 
										and (m3_axis_video_tid = tid) and (m3_axis_video_tdest = tdest)) then
									status_pruefung(0) <= '1';
								else
									status_pruefung(0) <= '0';
								end if;
							end if;
						--
						elsif ((m3_axis_video_tdata(7 downto 0) = daten_2_1) 
							and (m3_axis_video_tdata(15 downto 8) = daten_2_2)
							and (m3_axis_video_tdata(23 downto 16) = daten_2_3)) then
							data_pruefung(7 downto 4) <= "1111";
							if (state_read = DATEN_2) then
								state_read <= DATEN_3;
								-- weitere berprfung der Statussignale
								if ((m3_axis_video_tuser = '0') and (m3_axis_video_tlast = '0')
									and (m3_axis_video_tstrb = tstrb) and (m3_axis_video_tkeep = tkeep) 
									and (m3_axis_video_tid = tid) and (m3_axis_video_tdest = tdest)) then
									status_pruefung(1) <= '1';
								else
									status_pruefung(1) <= '0';
								end if;
							end if;
						--
						elsif ((m3_axis_video_tdata(7 downto 0) = daten_3_1) 
								and (m3_axis_video_tdata(15 downto 8) = daten_3_2)
								and (m3_axis_video_tdata(23 downto 16) = daten_3_3)) then
							data_pruefung(11 downto 8) <= "1111";
							if (state_read = DATEN_3) then
								state_read <= DATEN_4;
								-- weitere berprfung der Statussignale
								if ((m3_axis_video_tuser = '0') and (m3_axis_video_tlast = '0')
									and (m3_axis_video_tstrb = tstrb) and (m3_axis_video_tkeep = tkeep) 
									and (m3_axis_video_tid = tid) and (m3_axis_video_tdest = tdest)) then
									status_pruefung(2) <= '1';
								else
									status_pruefung(2) <= '0';
								end if;
							end if;
						--
						elsif ((m3_axis_video_tdata(7 downto 0) = daten_4_1) 
								and (m3_axis_video_tdata(15 downto 8) = daten_4_2)
								and (m3_axis_video_tdata(23 downto 16) = daten_4_3)) then
							data_pruefung(15 downto 12) <= "1111";
							if (state_read = DATEN_4) then
								state_read <= STREAM_BEREIT;
								-- weitere berprfung der Statussignale
								if ((m3_axis_video_tuser = '0') and (m3_axis_video_tlast = '1')
									and (m3_axis_video_tstrb = tstrb) and (m3_axis_video_tkeep = tkeep) 
									and (m3_axis_video_tid = tid) and (m3_axis_video_tdest = tdest)) then
									status_pruefung(3) <= '1';
								else
									status_pruefung(3) <= '0';
								end if;
							end if;
						--	
						else
							data_pruefung <= (others => '0');
							status_pruefung <= (others => '0');
							--state_read <= STREAM_BEREIT;
						end if;
					else
						data_pruefung <= (others => '0');
						status_pruefung <= (others => '0');
					end if;
				end if;
			end if;
		end if;
	end process;

	-- zur besseren Sichtbarkeit whrend der Simulation
	testpins_2 <= data_pruefung;
	testpins_3 <= status_pruefung;
	
	-- Ergebnis auf LEDs legen
	led_red <= status_pruefung;																	-- zeigt demnach den aktuellen Datenstatus
	led_green <= '1' when data_pruefung = (data_pruefung'range => '1') else '0';	-- blinkt nur dann kurz auf, wenn alle Daten in einem Zyklus stimmen


	-- Virtual FIFO Controller
	-- -----------------------
	Virtual_FIFO_Controller : vfifo	
		port map (
			aclk => aclk,
			aresetn => aresetn,
			
			m_axi_awid => m_axi_awid,
			m_axi_awaddr => m_axi_awaddr,
			m_axi_awlen => m_axi_awlen,
			m_axi_awsize => m_axi_awsize,
			m_axi_awburst => m_axi_awburst,
			m_axi_awlock => m_axi_awlock,
			m_axi_awcache => m_axi_awcache,
			m_axi_awprot => m_axi_awprot,
			m_axi_awqos => m_axi_awqos,
			m_axi_awregion => m_axi_awregion,
			m_axi_awuser => m_axi_awuser,
			m_axi_awvalid => m_axi_awvalid,
			m_axi_awready => m_axi_awready,
			
			m_axi_wdata => m_axi_wdata,
			m_axi_wstrb => m_axi_wstrb,
			m_axi_wlast => m_axi_wlast,
			m_axi_wuser => m_axi_wuser,
			m_axi_wvalid => m_axi_wvalid,
			m_axi_wready => m_axi_wready,
			
			m_axi_bid => m_axi_bid,
			m_axi_bresp => m_axi_bresp,
			m_axi_buser => m_axi_buser,
			m_axi_bvalid => m_axi_bvalid,
			m_axi_bready => m_axi_bready,
			
			m_axi_arid => m_axi_arid,
			m_axi_araddr => m_axi_araddr,
			m_axi_arlen => m_axi_arlen,
			m_axi_arsize => m_axi_arsize,
			m_axi_arburst => m_axi_arburst,
			m_axi_arlock => m_axi_arlock,
			m_axi_arcache => m_axi_arcache,
			m_axi_arprot => m_axi_arprot,
			m_axi_arqos => m_axi_arqos,
			m_axi_arregion => m_axi_arregion,
			m_axi_aruser => m_axi_aruser,
			m_axi_arvalid => m_axi_arvalid,
			m_axi_arready => m_axi_arready,
			
			m_axi_rid => m_axi_rid,
			m_axi_rdata => m_axi_rdata,
			m_axi_rresp => m_axi_rresp,
			m_axi_rlast => m_axi_rlast,
			m_axi_ruser => m_axi_ruser,
			m_axi_rvalid => m_axi_rvalid,
			m_axi_rready => m_axi_rready,
			
			-- diese (folgenden) Sektionen sind bereits angepasst (Video-Eingangs- und Ausgangsstream)
			s_axis_tvalid => m_axis_video_tvalid,					--
			s_axis_tready => m_axis_video_tready,					-- 
			s_axis_tdata(23 downto 0) => m_axis_video_tdata,	-- lsst sich so synthetisieren, ob es so richtig ist, ist noch nicht engltig klar
			s_axis_tdata(31 downto 24) => nullsignal,				-- lsst sich so synthetisieren, ob es so richtig ist, ist noch nicht engltig klar
			s_axis_tstrb => m_axis_video_tstrb,
			s_axis_tkeep => m_axis_video_tkeep,
			s_axis_tlast => m_axis_video_tlast,						--
			s_axis_tid => m_axis_video_tid,
			s_axis_tdest => m_axis_video_tdest,
			s_axis_tuser(0) => m_axis_video_tuser,					-- Anpassung von std_logic_vector(0 downto 0) auf std_logic
			
			m_axis_tvalid => m3_axis_video_tvalid,				--
			m_axis_tready => m3_axis_video_tready,				--
			m_axis_tdata(23 downto 0) => m3_axis_video_tdata,-- lsst sich so synthetisieren, ob es so richtig ist, ist noch nicht engltig klar
			m_axis_tdata(31 downto 24) => nullsignal,				-- lsst sich so synthetisieren, ob es so richtig ist, ist noch nicht engltig klar
			m_axis_tstrb => m3_axis_video_tstrb,
			m_axis_tkeep => m3_axis_video_tkeep,
			m_axis_tlast => m3_axis_video_tlast,					--
			m_axis_tid => m3_axis_video_tid,
			m_axis_tdest => m3_axis_video_tdest,
			m_axis_tuser(0) => m3_axis_video_tuser,				-- Anpassung von std_logic_vector(0 downto 0) auf std_logic
			
			vfifo_mm2s_channel_full => vfifo_mm2s_channel_full,
			vfifo_s2mm_channel_full => vfifo_s2mm_channel_full,
			vfifo_mm2s_channel_empty => vfifo_mm2s_channel_empty,
			vfifo_idle => vfifo_idle
		);

	-- MIG mit einem einzelnen 32bit bidirektionalen Port
	-- --------------------------------------------------
	Memory_interface_controller : mig 
		generic map (
			C3_P0_MASK_SIZE => 4,
			C3_P0_DATA_PORT_SIZE => 32,
			C3_P1_MASK_SIZE => 4,
			C3_P1_DATA_PORT_SIZE => 32,
			DEBUG_EN => 0,
			C3_MEMCLK_PERIOD => 3000,
			C3_CALIB_SOFT_IP => "TRUE",
			C3_SIMULATION => "FALSE",
			C3_RST_ACT_LOW => 0,
			C3_INPUT_CLK_TYPE => "SINGLE_ENDED",
			C3_MEM_ADDR_ORDER => "ROW_BANK_COLUMN",
			C3_NUM_DQ_PINS => 16,
			C3_MEM_ADDR_WIDTH => 14,
			C3_MEM_BANKADDR_WIDTH => 3,
			C3_S0_AXI_STRICT_COHERENCY => 0,
			C3_S0_AXI_ENABLE_AP => 0,
			C3_S0_AXI_DATA_WIDTH => 32,
			C3_S0_AXI_SUPPORTS_NARROW_BURST => 1,
			C3_S0_AXI_ADDR_WIDTH => 32,
			C3_S0_AXI_ID_WIDTH => 1
		)
		port map (
			-- Ein- und Ausgnge zum Speicher
			mcb3_dram_dq => mcb3_dram_dq,  
			mcb3_dram_a => mcb3_dram_a,  
			mcb3_dram_ba => mcb3_dram_ba,
			mcb3_dram_ras_n => mcb3_dram_ras_n,                        
			mcb3_dram_cas_n => mcb3_dram_cas_n,                        
			mcb3_dram_we_n => mcb3_dram_we_n,                          
			mcb3_dram_odt => mcb3_dram_odt,
			mcb3_dram_cke => mcb3_dram_cke,                          
			mcb3_dram_ck => mcb3_dram_ck,                          
			mcb3_dram_ck_n => mcb3_dram_ck_n,       
			mcb3_dram_dqs => mcb3_dram_dqs,                          
			mcb3_dram_dqs_n => mcb3_dram_dqs_n,
			mcb3_dram_udqs => mcb3_dram_udqs,		-- for X16 parts                        
			mcb3_dram_udqs_n => mcb3_dram_udqs_n,	-- for X16 parts
			mcb3_dram_udm => mcb3_dram_udm,			-- for X16 parts
			mcb3_dram_dm => mcb3_dram_dm,
			mcb3_dram_reset_n => mcb3_dram_reset_n,
			mcb3_rzq => mcb_rzq3,
			-- Kalibrierung und Clock (Funktion noch nicht ganz klar)
														-- Zwischenstand:
			c3_sys_clk => c3_sys_clk,			-- Genereller Clock Eingang
			c3_sys_rst_i => c3_sys_rst_i,    -- Genereller Reset Eingang
			c3_calib_done => c3_calib_done,	-- Kalibrierung des Speichers abgeschlossen
			c3_clk0 => aclk,						-- Genereller Clock Ausgang fr alle weiteren Module
			c3_rst0 => rst,						-- Genereller Reset Ausgang fr alle weiteren Module
			
			-- write adress channel
				-- nicht verwendete Signale:
				-- signal m_axi_awregion : std_logic_vector(3 downto 0) := "0000";	-- Region Identifier; immer 0
				-- signal m_axi_awuser : std_logic_vector(0 downto 0) := "0";			-- Write Adress Channel User; immer 0
			c3_s0_axi_aclk => c3_s0_axi_aclk,
			c3_s0_axi_aresetn => aresetn,
			--
			c3_s0_axi_awid => m_axi_awid,				-- Channel Identifier (Ziel als Routing Information)
			c3_s0_axi_awaddr => m_axi_awaddr,		-- Write Adresse (erste Adresse Burst Zyklus)
			c3_s0_axi_awlen => m_axi_awlen,			-- Lnge des Burst Zyklus (genaue Anzahl)
			c3_s0_axi_awsize => m_axi_awsize,		-- Burst Gre (gre jedes Transfers im Burstzyklus; hngt von der Datenbreite ab)
			c3_s0_axi_awburst => m_axi_awburst,		-- Art des Burst; immer gesetzt auf inkrementierte Transfer
			c3_s0_axi_awlock => m_axi_awlock,		-- Lock Type; immer 0
			c3_s0_axi_awcache => m_axi_awcache,		-- Cache Typ; immer 0
			c3_s0_axi_awprot => m_axi_awprot,		-- Protection type; immer 0
			c3_s0_axi_awqos => m_axi_awqos,			-- Quality of Service; immer 0
			c3_s0_axi_awvalid => m_axi_awvalid,		-- Write Adress Valid; Angabe, ob gltige Write Adress- und Kontrollinformationen verfgbar sind (1 = valid)
			c3_s0_axi_awready => m_axi_awready,		-- Write Adress Ready; zeigt an, ob der Slave bereit ist eine Adresse zu empfangen
			-- write data channel Signale
				-- nicht verwendete Signale:
				-- signal m_axi_wuser : std_logic_vector(0 downto 0) := "0";	-- EOL
			c3_s0_axi_wdata => m_axi_wdata,			-- Write Daten
			c3_s0_axi_wstrb => m_axi_wstrb,			-- Write Strobes; ??? (S.19)
			c3_s0_axi_wlast => m_axi_wlast,			-- zeigt den letzten Transfer in einem Burst Zyklus an
			c3_s0_axi_wvalid => m_axi_wvalid,		-- Write Valid; ob Lesedaten verfgbar sind (1 = Write-Daten und Strobes sind verfgbar)
			c3_s0_axi_wready => m_axi_wready,		-- Write Ready; ob Slave bereit ist Daten zu aktzeptieren (1 = Slave bereit)
			-- Write Response Channel Signale
				-- nicht verwendete Signale:
				-- signal m_axi_buser : std_logic_vector(0 downto 0) := "0";	-- EOL
			c3_s0_axi_bid => m_axi_bid,				-- Antwort ID...
			c3_s0_axi_wid => m_axi_wid,				-- Write ID ??? -> Signal existiert nicht -> ist es wichtig???????????????????????????????????????????????????????????????????????????????????????????
			c3_s0_axi_bresp => m_axi_bresp,			-- Write Response; Status des Schreibevorgangs (erlaubt sind: OKAY,EXOKAY,SLVERR,DECERR)
			c3_s0_axi_bvalid => m_axi_bvalid,		-- Write Response Valid - zeigt an, ob eine gltige Schreibantwort verfgbar ist
			c3_s0_axi_bready  => m_axi_bready,		-- Response Ready - zeigt an, ob der Master die Anwort empfangen kann (1 = ready)
			-- Read Adress Channel Signale
				-- nicht verwendete Signale:
				-- signal m_axi_arregion : std_logic_vector(3 downto 0) := "0000";	-- Region Indentifier; immer 0
				-- signal m_axi_aruser : std_logic_vector(0 downto 0) := "0";			-- Read Adress Channel User; immer 0
			c3_s0_axi_arid => m_axi_arid,				-- Leseadress-ID (immer 0; alle konfigurierten Kanle haben Zugang zu einem einzelnen Adressbereich im Memory Map Interconnect...)
			c3_s0_axi_araddr => m_axi_araddr,		-- Leseadresse (erste Adresse Burstzyklus)
			c3_s0_axi_arlen => m_axi_arlen,			-- Burst Lnge (exakte Anzahl von Transferen in einem Burst)
			c3_s0_axi_arsize => m_axi_arsize,		-- Burst Gre (Gre eines jeden Transfers im Burst; basierend auf Datenbreite des Interfaces)
			c3_s0_axi_arburst => m_axi_arburst,		-- Burst Type (gekoppelt mit Greninformation, Details, wie jede Adressein einem Transfer zu adressieren ist,...)
			c3_s0_axi_arlock => m_axi_arlock,		-- Lock Type; immer 0
			c3_s0_axi_arcache => m_axi_arcache,		-- Cache Type; immer 0
			c3_s0_axi_arprot => m_axi_arprot,		-- Protection Type; immer 0
			c3_s0_axi_arqos => m_axi_arqos,			-- Quality of Service; immer 0
			c3_s0_axi_arvalid => m_axi_arvalid,		-- Read Adress Valid; Angabe, ob gltige Read Adress- und Kontrollinformationen verfgbar sind (1 = valid)
			c3_s0_axi_arready => m_axi_arready,		-- Read Adress Ready; zeigt an, ob der Slave bereit ist Adress- und zugehrige Kontrollinformation zu empfangen (1 = ready)
			-- Read Data Channel Signale
				-- nicht verwendete Signale:
				-- signal m_axi_ruser : std_logic_vector(0 downto 0) := "0";	
			c3_s0_axi_rid => m_axi_rid,				-- Read ID Tag; ...; erzeugt im Slave; nicht genutzt im VFIFO
			c3_s0_axi_rdata => m_axi_rdata,			-- Read Data
			c3_s0_axi_rresp => m_axi_rresp,			-- Read Response; zeigt den Status des Lesetransfers an (erlaubt sind: OKAY,EXOKAY,SLVERR,DECERR)
			c3_s0_axi_rlast => m_axi_rlast,			-- Read Last; letzter Transfer in einem Leseburst
			c3_s0_axi_rvalid => m_axi_rvalid,		-- Lesedaten verfgbar (1 = Daten verfgbar)
			c3_s0_axi_rready => m_axi_rready			-- ob Master bereit ist die Lesedaten und Antwortinformationen zu bekommen (ready = 1)
		);


end Behavioral;
